'FFSubmenu=Rahmen
'FFName=Overlapped

' ********************************************************************
' Overlapped.vbs (Skript fr FixFoto)
' Funktion:	Collage berlappender Bilder erstellen
'
' Copyright Harald Maeckler, Dsseldorf 2013 - 2016
' ********************************************************************
'
' Version 3.02 vom 27.03.2016	- Skript-URL gem Forenberarbeitung gendert
'								- Forenwei gendert auf "250 250 250"
' Version 3.01 vom 20.03.2014	- Wiederhestellung der Spaltenzahl wenn zulssig nach Neustart
'								- Verbesserung der Zwischenraumberechnung
' Version 3.00 vom 19.03.2014	- whlbare Lage bei weniger Bildern in der Zeile als Spalten
'								- Bug bei Zeilenberechnung korrigiert (Sub ZwertEintrag)
' Version 2.03 vom 01.03.2014	- Hintergrundfarbe des FF-Forums setzbar fr
'									Zwischenraum bzw. Fuge
' Version 2.02 vom 03.02.2014	- Bug in der Exif-Datenerzeugung behoben
' Version 2.01 vom 01.02.2014	- Toleranz fr das Seitenverhltnis auf 1 % verkleinert
'								- Meldung bei zum Kacheln nicht passender Bilderanzahl gendert
' Version 2.00 vom 28.01.2014	- kleine Bugs beseitigt
'								- optional 'Normierung' der ausgewhlten Bilder
'									wahlweise mit automatischem oder manuellem Beschnitt
'								- optional 'Kacheln (mit Schattenbildung)' nach Normierung
'									bei gleicher Anzahl von Bildern je Zeile
' Version 1.04 vom 02.01.2014	- Ausnutzung der Befehlserweiterung von FF_MakeBanner
'										um die Farbe fr Zwischenrume mit negativem lap-Wert
'								- Bug bei Ermittlung zulssiger Zeilenwerte abhngig von
'										der ausgewhlten Bildernanzahl beseitigt
'								- Nachschrfung als Option
'								- Grenzwert fr Sicherheitsfrage wegen mglichen Speichermangels
'										angehoben auf 30 Bilder
'								- Nachtrag: Farbe fr zwischenraum in 'Werte auslesen' korrigiert (20.1.14)
' Version 1.03 vom 28.12.2013	- Kompatibilitt zu FF-Version 3.50.37 hergestellt
' Version 1.02 vom 22.12.2013	- manchmal erscheinendes Geisterbild in der ersten Zeile wird verhindert
'								- eingegebene Collagebreite steht nach nchstem Start wieder zur Verfgung
'								- bei Gesamtrahmen = 0 wird Rahmenfarbe ausgeblendet
'								- Bilderauswahl fr alle bzw. markierte Bilder im Comp.-Verz. oder Bilderliste
'								- bei mehr als 12 ausgewhlten Bildern erfolgt eine Sicherheitsabfrage
'								- gewhlte Zeilenanzahl und Zeilenwahl fr verringerte Bilderanzahl
'										wird bei nchstem Start mglichst wieder hergestellt
' Version 1.01 vom 18.12.2013	- Bug bei mehrmaligem 'Neu'-Aufruf beseitigt
'								- berlappungswerte erweitert bis auf 100 Promille
' Version 1.00 vom 16.12.2013	- Betaversion
' ********************************************************************

Option Explicit

'Updatekonstanten und Variable
const SkriptVersion = "3.02"
const SkriptURL = "http://www.ffsf.de/resources/overlapped.161/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

Dim SkriptName
const Skript = "Overlapped"									'Skriptname
const RegSchluessel = "FF_Overlapped"						'Registryschlssel

Dim objFS,WshShell											'Objekte
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

Dim SkriptKill,Antwort,TempFile	 : SkriptKill = false		'Lschroutine

Dim Abbruch,Anzeige											'Allgemein

'Skriptkonstanten
const ZeilenKontrolle = true	'true ist Standard (nicht realisierbare Zeilen werden nicht zur Auswahl angeboten)
const Bwerte = "alle Bilder der Computeransicht,mark.Bilder der Computeransicht,alle Bilder der akt. Bilderliste,mark. Bilder der akt. Bilderliste"
const Rwerte = "100,90,80,70,60,50,40,30,20,15,10,5,3,2,1,0,-1,-2,-3,-5,-10,-15,-20,-30"
const Ewerte = "0,1,2,3,5,10,15,20,30"
const Nwerte = " 1 :  1, 9 :  7, 4 :  3, 7 :  5,DinA quer, 3 :  2,16 : 10,16 :  9, 9 : 16,10 : 16, 2 :  3,DinA hoch, 5 :  7, 3 :  4, 7 :  9"
const SVzahl = "1,000/1,286/1,333/1,400/1,414/1,500/1,600/1,778/0,563/0,625/0,667/0,707/0,714/0,750/0,778"
const RGB_S = true : const Y_S = false
const Schaerfegrade = "keine/schwach/mittel/stark"
const S_schwach = 20 : const S_mittel = 30 : const S_stark = 40

'Skriptvariable
Dim BwertArray,RwertArray,EwertArray,SwertArray,element
Dim msgBanz,Zanz,Zv,Sanz,SRanz,Babgl,Zabgl,msgAbgl,flagLage,LgWert
Dim AK,Sbreite,Rwert,Rfarbe,Rfarbwert,RRfarbe
Dim Ewert,Ewertpx,Efarbe,Efarbwert,msgRwert
Dim Collection,Schaerfe,Tmp,Zunz
Zunz = false	'Zeilenzahl unzulssig
Dim NwertArray,SVzahl_Array,flag_Normierung,Nwert,SVsoll,Markierung,flag_Bautomatik
const SVtoleranz = 1	'Toleranz des Seitenverhltnis in Prozent
Dim flag_Kacheln,AnzahlH,AnzahlV,LinSt,Breite,Hoehe,RahSt
Dim Kachelbreite,Kachelhoehe,KachelSh_H,KachelSh_V

Dim bildN,Bildname
Dim bilder,bilderArray,maxanz,n,z,s,Gbreite,zBilder,zGbilder,lapPx

'------------------------------------------------------------------------
call Main
'------------------------------------------------------------------------
Sub Main	'### Hauptprogramm

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if Err.Number > 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbs") then
	SkriptName = Skript & ".vbs"
elseif objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbe") then
	SkriptName = Skript & ".vbe"
else
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

if not Version_OK("3.40.00") then
	msgbox  "Es muss mindestens die" & vbNewLine & _
			"FixFoto-Version 3.40 installiert sein!",vbExclamation,"Abbruch"
	exit sub
end if

'Allgemein
Tmp = FF_GetScriptPath & "\MeckiScript\Overlapped\Tmp"		'temporrer Ordner
bildN = Tmp & "\temp"

'** Start Dialog Overlapped **
FF_AddDialog "Overlapped",196,158
FF_AddControl "Overlapped","Bilderauswahl","GROUP",5,6,100,41
FF_AddControl "Overlapped","Auswahl","COMBO",9,18,92,10
FF_AddControl "Overlapped","Aktualisieren","BUTTON",39,31,36,12
FF_AddControl "Overlapped","Normierung","GROUP",109,5,82,42
FF_AddControl "Overlapped","flag_Normierung","BOOL",170,5,8,8
FF_SetControlStyle "Overlapped","flag_Normierung",16384
FF_AddControl "Overlapped","Breite zu Hhe","STATIC",113,18,36,10
FF_AddControl "Overlapped","SV_Auswahl","COMBO",150,18,37,10
FF_AddControl "Overlapped","flag_Bautomatik","BOOL",113,33,8,8
FF_AddControl "Overlapped","automatisch","STATIC",122,32,30,10
FF_AddControl "Overlapped","flag_Kacheln","BOOL",158,33,8,8
FF_SetControlStyle "Overlapped","flag_Kacheln",16384
FF_AddControl "Overlapped","Kacheln","STATIC",168,32,20,10
FF_AddControl "Overlapped","|||||","STATIC",5,50,186,11
FF_SetControlStyle "Overlapped","|||||",1
FF_AddControl "Overlapped","Bilderanordnung","GROUP",5,64,76,62
FF_AddControl "Overlapped","Zeilenanzahl","STATIC",10,74,44,10
FF_AddControl "Overlapped","Zanz","COMBO",55,74,22,10
FF_AddControl "Overlapped","Spaltenanzahl","STATIC",10,86,44,10
FF_AddControl "Overlapped","Sanz","COMBO",55,86,22,10
FF_AddControl "Overlapped","||","STATIC",10,100,44,10
FF_AddControl "Overlapped","Zabgl","COMBO",55,100,22,11
FF_AddControl "Overlapped","flagLage","BOOL",10,114,8,8
FF_AddControl "Overlapped","LgWert","COMBO",47,113,30,10
FF_AddControl "Overlapped","Layout","GROUP",86,64,105,62
FF_AddControl "Overlapped","Collagebreite","STATIC",91,74,38,10
FF_AddControl "Overlapped","Sbreite","EDIT",129,74,22,10
FF_SetControlStyle "Overlapped","Sbreite",8193
FF_AddControl "Overlapped","px","STATIC",153,74,8,10
FF_AddControl "Overlapped","FF","IMAGE",170,69,16,14
FF_AddControl "Overlapped","|||","STATIC",91,86,38,10
FF_AddControl "Overlapped","Rwert","COMBO",129,86,22,10
FF_AddControl "Overlapped","","STATIC",153,85,8,10
FF_AddControl "Overlapped","Rfarbe","COLOR",162,85,25,12
FF_AddControl "Overlapped","Gesamtrahmen","STATIC",91,100,38,10
FF_AddControl "Overlapped","Ewert","COMBO",129,100,22,10
FF_AddControl "Overlapped","|","STATIC",153,99,8,10
FF_AddControl "Overlapped","Efarbe","COLOR",162,100,25,12
FF_AddControl "Overlapped","Nachschrfung","STATIC",91,113,38,10
FF_AddControl "Overlapped","Schaerfe","COMBO",141,113,36,10
FF_AddControl "Overlapped","Fortschritt","PROGRESS",5,131,186,4
FF_AddControl "Overlapped","?","BUTTON",10,142,11,11
FF_AddControl "Overlapped","|","STATIC",25,142,22,11
FF_SetControlStyle "Overlapped","|",1
FF_AddControl "Overlapped","Update","BUTTON",49,142,33,11
FF_AddControl "Overlapped","Abbrechen","BUTTON",116,142,33,11
FF_AddControl "Overlapped","Start","BUTTON",154,142,33,11
FF_AddControl "Overlapped","&delete","BUTTON",7,66,1,1
FF_AddControl "Overlapped","||||","STATIC",20,113,24,10
'** End Dialog Overlapped **

'Voreinstellung
BwertArray = split(Bwerte,",")
for each element in BwertArray
	FF_SetControl "Overlapped","Auswahl",element
next

FF_SetControl "Overlapped","LgWert","Links"
FF_SetControl "Overlapped","LgWert","Mitte"
FF_SetControl "Overlapped","LgWert","Rechts"

RwertArray = split(Rwerte,",")

EwertArray = split(Ewerte,",")
for each element in EwertArray
	FF_SetControl "Overlapped","Ewert",element
next

NwertArray = split(Nwerte,",")
for each element in NwertArray
	FF_SetControl "Overlapped","SV_Auswahl",element
next

SwertArray = split(Schaerfegrade,"/")
for each element in SwertArray
	FF_SetControl "Overlapped","Schaerfe",element
next

FF_SetControl "Overlapped","FF",FF_GetScriptPath & "\MeckiScript\Overlapped\img_FF.png"

'Registry
call RegistryLesen

'Normierung
if flag_Normierung = 0 then
	FF_EnableControl "Overlapped","SV_Auswahl", false
	FF_EnableControl "Overlapped","flag_Bautomatik", false
	FF_EnableControl "Overlapped","flag_Kacheln", false
end if

'Bilderanordnung
call Bilderermittlung
if not Abbruch then
	call Bilderanordnung
else
	FF_SetControl "Overlapped","Zanz",""
	FF_SetControl "Overlapped","Sanz",""
	FF_SetControl "Overlapped","Zabgl",""
	FF_SetControl "Overlapped","||",""
end if
FF_SetControl "Overlapped","|||||",msgBanz

if SRanz > 0 and SRanz <= maxAnz then			'alten Spaltenwert eintragen
	Sanz = SRanz
	FF_SetControl "Overlapped","Sanz",Sanz
	call ZwertEintrag
end if

'Layout
call RwertEintrag
if Ewert = 0 then
	FF_EnableControl "Overlapped","Efarbe",false
end if

'Tooltips
FF_SetControlTooltip "Overlapped","Aktualisieren", "" &_
					"Aktualisierung der Bilderanordnung" & vbNewLine & _
					"nach nderung der Markierung von Bildern."
FF_SetControlTooltip "Overlapped","FF", "" &_
					"Hintergrundfarbe des FF-Forums" & vbNewLine &_
					"verwenden fr Zwischenraum bzw. Fuge"
FF_SetControlTooltip "Overlapped","?", "" &_
					"Anzeige der Kurzbeschreibung als PDF-Datei," & vbNewLine & _
					"vorausgesetzt es ist ein PDF-Reader installiert."
FF_SetControlTooltip "Overlapped","Update", "" &_
					"Prfung ob eine neue Version vorliegt."
FF_SetControlTooltip "Overlapped","Abbrechen", "" &_
					"Das Skript wird vorzeitig beendet."
FF_SetControlTooltip "Overlapped","Start", "" &_
					"Die Collage wird erstellt."

if Version_OK("3.40.52") then FF_SetTooltipDelay 3000
FF_ActivateControl "Overlapped","&delete"
FF_SetDialogTimer "Overlapped", 100

do
	Abbruch = false
	Select Case FF_ShowDialog ("Overlapped")

	Case "TIMER"
		FF_SetControl "Overlapped" ,"|","V " & Skriptversion
		FF_SetControl "Overlapped" ,"||",msgAbgl
		FF_SetControl "Overlapped" ,"|||",msgRwert
		if Babgl > 0 then FF_SetControl "Overlapped","||||","hor. Lage"
		FF_SetControl "Overlapped" ,"|||||",msgBanz
		FF_SetDialogTimer "Overlapped", 0
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "Aktualisieren","Auswahl"
		for n = 0 to ubound(BwertArray)
			if BwertArray(n) = FF_GetControl("Overlapped","Auswahl") then
				AK = n
				exit for
			end if
		next
		call Bilderermittlung
		if not Abbruch then
			call Bilderanordnung
		else
			FF_SetControl "Overlapped","Zanz",""
			FF_SetControl "Overlapped","Sanz",""
			FF_SetControl "Overlapped","Zabgl",""
			FF_SetControl "Overlapped","||",""
		end if
		FF_SetControl "Overlapped","|||||",msgBanz
	Case "Test_SV_Auswahl"	'Test der SV_Auswahl
		Nwert = FF_GetControl("Overlapped","SV_Auswahl")
		SVsoll = ""
		SVzahl_Array = split(SVzahl,"/")
		for n = 0 to ubound(NwertArray)
			if NwertArray(n) = Nwert then
				SVsoll = SVzahl_Array(n)
				exit for
			end if
		next
		if len(SVsoll) = 0 then
			msgbox"Fehler beim Seitenverhltnis!",vbExclamation,"Fehler"
		else
			msgbox SVsoll
		end if
	Case "flag_Normierung"
		flag_Normierung = FF_GetControl("Overlapped","flag_Normierung")
		if flag_Normierung = 1 then
			FF_EnableControl "Overlapped","SV_Auswahl", true
			FF_EnableControl "Overlapped","flag_Bautomatik", true
			FF_EnableControl "Overlapped","flag_Kacheln", true
		else
			FF_EnableControl "Overlapped","SV_Auswahl", false
			FF_EnableControl "Overlapped","flag_Bautomatik", false
			FF_EnableControl "Overlapped","flag_Kacheln", false
		end if
		call RwertEintrag
	Case "flag_Kacheln"
		flag_Kacheln = FF_GetControl("Overlapped","flag_Kacheln")
		call  RwertEintrag
	Case "Zanz"
		Zanz = FF_GetControl("Overlapped","Zanz")
		call SwertEintrag
	Case "Sanz"
		Sanz = FF_GetControl("Overlapped","Sanz")
		call ZwertEintrag
	Case "FF"
		FF_SetControl "Overlapped","Rfarbe","250 250 250"
	Case "Rwert"
		Rwert = FF_GetControl("Overlapped","Rwert")
		call RwertEintrag
	Case "Ewert"
		Ewert = FF_GetControl("Overlapped","Ewert")
		if Ewert = 0 then
			FF_EnableControl "Overlapped","Efarbe", false
		else
			FF_EnableControl "Overlapped","Efarbe", true
		end if
	Case "?"
		'FF_SetControl "Overlapped","Fortschritt",65	'############## nur fr Screenshot
		Anzeige = """" & FF_GetScriptPath & "\MeckiScript\Overlapped\Overlapped.pdf" & """"
		on error resume next
		WshShell.Run Anzeige,1,false
		if err <> 0 then
			msgbox "Die Kurzbeschreibung konnte nicht als PDF-Datei geffnet werden." & vbNewLine & _
				   "Die Datei ist gelscht oder es ist kein PDF-Reader installiert (?).",vbExclamation,"Hinweis"
			err.clear
		end if
		on error GoTo 0
	Case "Update"
		SkriptEnde = false
		call Update
		if SkriptEnde then exit do
	Case "Start"
		if maxAnz < 2 then
			msgbox  "In der Computeransicht oder in der" & vbNewLine & _
			"aktuellen Bilderliste mssen mindestens" & vbNewLine & _
			"zwei Bilder markiert sein!",vbExclamation,"Abbruch"
		else
			if not objFS.FolderExists(Tmp) then objFS.CreateFolder(Tmp)
			call WerteAuslesen
			call Kontrolle
			if flag_Normierung then call Normierung
			FF_SetControl "Overlapped","Fortschritt",0
			if not Abbruch then
				if Version_OK("3.50.37") then
					call Collage
				else
					call Collage_alt
				end if
				if flag_Normierung = 1 and flag_Kacheln = 1 then call Kacheln
				FF_Reload
				exit do
			else
				if objFS.FolderExists(Tmp) then objFS.DeleteFolder Tmp,true
			end if
		end if
	Case "Abbrechen","CANCEL"
		Abbruch = true
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben
if objFS.FolderExists(Tmp) then objFS.DeleteFolder Tmp,true
FF_CloseDialog ("Overlapped")
if SkriptKill then	'ggf. Skript komplett entfernen
	call KillSkript
end if

End Sub
'------------------------------------------------------------------------
Sub Bilderermittlung
Dim blAnsicht,msg

blAnsicht = FF_GetSelection(AK)
bilderArray = split(blAnsicht,vbCrLf)
maxAnz = ubound(bilderArray) +1

if maxAnz < 2 then
	msgBanz = "Mindestens 2 Bilder markieren > dann 'Aktualisieren' bettigen"
	Abbruch = true
	exit sub
end if

Select Case AK
	Case 0,1
	msg = "im Computerverzeichnis"
	Case 2,3
	msg = "in der Bilderliste"
Case else
End select

msgBanz = "Es sind " & maxAnz & " Bilder " & msg & " ausgewhlt"

End Sub
'------------------------------------------------------------------------
Sub Bilderanordnung
Zv = false

'mgliche Zeilen eintragen
Zanz = Zanz *1
FF_SetControl "Overlapped","Zanz",""
for n = 1 to round((maxAnz +.1) /2)
	Sanz = maxAnz \ n										'Ermittlung der Spaltenzahl
	if maxAnz - n * Sanz > 0 then Sanz = Sanz +1			' mit Korrektur
	if ZeilenKontrolle then
		if  n * Sanz - Sanz < maxAnz then					'Kontrolle ob Zeilenzahl zulssig
			FF_SetControl "Overlapped","Zanz",n				'Eintrag der Zeilenzahl
			if n = Zanz then Zv = true
		end if
	else
		FF_SetControl "Overlapped","Zanz",n					'Eintrag der Zeilenzahl
		if n = Zanz then Zv = true
	end if
next
FF_SetControl "Overlapped","Zanz",maxAnz
if maxAnz = Zanz then Zv = true

'mgliche Spalten eintragen
FF_SetControl "Overlapped","Sanz",""
for n = 1 to maxAnz
	FF_SetControl "Overlapped","Sanz",n
next

'Mglichst alte Zeilenanzahl eintragen
if not Zv then
	Zanz = round(maxAnz ^.5)
end if

FF_SetControl "Overlapped","Zanz",Zanz
call SwertEintrag

End Sub
'------------------------------------------------------------------------
Sub Normierung
'Beschnitt auf gewhltes Seitenverhltnis
Dim Toleranz,Hist,Bist,Hsoll,Bsoll,SVist,BildTemp,X,Y

Toleranz = SVsoll / 100 * SVtoleranz
for n = 0 to ubound(bilderArray)
	Hist = FF_GetImageFileHeight(bilderArray(n))
	Bist = FF_GetImageFileWidth(bilderArray(n))
	SVist = Bist / Hist

	if SVist >= (SVsoll - Toleranz) and SVist <= (SVsoll + Toleranz) then
		if n = 0 then
			Collection = bilderArray(0)
		else
			Collection = Collection & vbCrLf & bilderArray(n)
		end if
	else
		'Beschnitt
		FF_LoadImage bilderArray(n)

		Hsoll = Hist : Bsoll = round(Hist * SVsoll)
		X = (Bist - Bsoll) \ 2 : Y = 0
		if Bsoll > Bist then
			Bsoll = Bist : Hsoll = round(Bist / SVsoll)
			X = 0 : Y = (Hist - Hsoll) \ 2
		end if

		if flag_Bautomatik = 1 then
			FF_Crop X,Y,Bsoll,Hsoll
		else
			call Beschnitt (Bsoll,Hsoll,Bist,Hist)
		end if
		if Abbruch then exit sub
		
		'Speichern
		BildTemp = BildN & "B" & objFS.GetBaseName(bilderArray(n)) & ".jpg"
		FF_SaveImage BildTemp,0
		if n = 0 then
			Collection = BildTemp
		else
			Collection = Collection & vbCrLf & BildTemp
		end if		
	end if
	
	FF_SetControl "Overlapped","Fortschritt",(n +1)/maxAnz *100
next

bilderArray = split(Collection,vbCrLf)

End Sub
'------------------------------------------------------------------------
Sub Beschnitt (Schnittbreite,Schnitthoehe,Bildbreite,Bildhoehe)
Dim SParameter,AntwortMD,SollHoch,IstHoch,msg,Param,X,Y

if Schnittbreite > Schnitthoehe then SollHoch = 1 else SollHoch = 0
if Bildbreite > Bildhoehe then IstHoch = 1 else IstHoch = 0
if Schnittbreite = Schnitthoehe then SollHoch = 1 : IstHoch = 1

if (SollHoch Xor IstHoch) = 0 then
	X = (Bildbreite - Schnittbreite) \ 2
	Y = (Bildhoehe - Schnitthoehe) \ 2
	FF_SetParam X & "," & Y & "," & Schnittbreite & "," & Schnitthoehe & "," & Bildbreite & "," & Bildhoehe & "," & Markierung & ",1"
else
	if IstHoch = 1 then 
		msg = "Ein querformatiges Bild soll hochformatig beschnitten werden."
	else
		msg = "Ein hochformatiges bzw. quadratisches Bild soll querformatig beschnitten werden."
	end if
	
	msgbox msg & vbNewLine & "Daher muss im folgenden Dialog die Taste 'Hoch/Quer' bettigt werden!", _
			   vbInformation,"Unbedingt beachten!"
	
	X = (Bildbreite - Schnitthoehe) \ 2
	Y = (Bildhoehe - Schnittbreite) \ 2
	FF_SetParam Y & "," & X & "," & Schnittbreite & "," & Schnitthoehe & "," & Bildhoehe & "," & Bildbreite & "," & Markierung & ",1"
end if

	AntwortMD = FF_MultiDialog ("MultiCanvas",2)
	if AntwortMD < 0 then
		msgbox "Das Bild wurde nicht beschnitten." & vbNewLine & _
				"Die Bearbeitung wird abgebrochen!",vbExclamation,"Hinweis"
		Abbruch = true
		exit sub
	end if

'gewhlte Markierungsart speichern
Param = split(FF_GetParam,",")
Markierung = Param(6)

'Kontrolle ob Taste 'Hoch/Quer' bettigt wurde
if abs(round(Schnittbreite/Schnitthoehe,2) - round(Param(2)/Param(3),2)) > 0.01 then
	msgbox "Das Seitenverhltnis entspricht nicht den Vorgaben." & vbNewLine & _
		   "Mglicherweise wurde 'Hoch/Quer' nicht oder flschlicherweise bettigt." & vbNewline & vbNewLine & _
		   "Die Bearbeitung wird abgebrochen!",vbExclamation,"Abbruch"
	Abbruch = true
	exit sub	
end if

End Sub
'------------------------------------------------------------------------
Sub Kacheln
'Vorbereitung zur Erzeugung von Kacheln mit Schatten

'Zuordnungen
AnzahlH = Sanz : AnzahlV = Zanz

Breite = FF_GetImageWidth()
Hoehe = FF_GetImageHeight()

Kachelbreite = round(Breite / AnzahlH)	'ganzzahlige Kachelbreite
Breite = AnzahlH * Kachelbreite			'neue Breite mit ganzzahliger Kachelbreite
Kachelbreite = Breite / AnzahlH

Kachelhoehe = round(Hoehe / AnzahlV)	'ganzzahlige Kachelhhe
Hoehe = AnzahlV * Kachelhoehe			'neue Hhe mit ganzzahliger Kachelhhe
Kachelhoehe = Hoehe / AnzahlV

FF_HQScale Breite, Hoehe, false	'skalieren auf neue Breite und Hhe

KachelSh_H = Breite + AnzahlH * LinSt
KachelSh_V = Hoehe + AnzahlV * LinSt

'temporr speichern
TempFile = Tmp & "\temp.bmp"
FF_SaveImage TempFile,0

call Schattenbildung_mV

End Sub
'------------------------------------------------------------------------
Sub Schattenbildung_mV
'neues Bild mit Kachelschatten mit Versatz

Dim y,yo,x,xo,i,xs,ys,Transparenz

FF_NewImage KachelSh_H,KachelSh_V,RRfarbe
for y = 0 to Hoehe step Kachelhoehe					'Vertikale
	if y = 0 then yo = 0 else yo = yo + LinSt
	
	for x = 0 to Breite step Kachelbreite			'Horizontale
		if x = 0 then xo = 0 else xo = xo + LinSt

		for i = LinSt - 1 to i = 1 step - 1
			Transparenz = (LinSt-i) * 255 / (LinSt-1)
			xs = x + i + xo
			ys = y + i + yo
			FF_AreaFillRect xs,ys,xs+Kachelbreite,ys+Kachelhoehe,Transparenz
		next
	next
next

FF_AdjustRGB 0,0,0
FF_PushImage

call OriginalMix_mV

End sub
'---------------------------------------------------------------------
Sub OriginalMix_mV
'Originalbild mixen mit Schattenbild mit Versatz

Dim y,yo,x,xo,xs,ys

for y = 0 to Hoehe - .5 step Kachelhoehe						'Vertikale
	if y = 0 then yo = 0 else yo = yo + LinSt

	for x = 0 to Breite - .5 step Kachelbreite					'Horizontale
		if x = 0 then xo = 0 else xo = xo + LinSt
		
		FF_LoadImage TempFile
		FF_Crop x,y,Kachelbreite,Kachelhoehe					'Ausschneiden
			
		xs = x + xo
		ys = y + yo
		FF_MixImage xs,ys,Kachelbreite,Kachelhoehe,255			'Mischen
	next
next

FF_PopImage

'Erweiterung links und oben
FF_ExtendCanvas LinSt,0,LinSt,0,Rfarbwert(0),Rfarbwert(1),Rfarbwert(2)

'Endrahmen
if RahSt *1 > 0 then
	FF_ExtendCanvas RahSt,RahSt,RahSt,RahSt,Efarbwert(0),Efarbwert(1),Efarbwert(2)
end if

'Bildgre rekonstruieren
FF_HQScale Sbreite,Sbreite * FF_GetImageHeight / FF_GetImageWidth,false

'Exif-Daten
if FF_HasExif then FF_KillExif 
FF_CreateExif
FF_SetExifTag "ImageDescription","Collage"
FF_SetExifTag "UserComment","erstellt mit den Bildern:" & vbCrLf & Collection
FF_SetExifTag "Software","FF-Skript Overlapped"

End sub
'---------------------------------------------------------------------
Sub SwertEintrag
'Eintrag des Spaltenwerts nach Vorgabe des Zeilenwerts

Sanz = maxAnz \ Zanz
Babgl = maxAnz - Zanz * Sanz
if Babgl > 0 then
	Sanz = Sanz +1
	Babgl = (Zanz * Sanz - maxAnz - Sanz) * -1
end if

if Babgl < 0 then	'nur zur Sicherheit, eigentlich berflssig
	msgbox Zanz & " Zeilen sind bei" & vbNewLine & maxAnz & " Bildern nicht darstellbar!",vbInformation,"Hinweis"
	Zanz = Zanz + Babgl
	call SwertEintrag
end if

call SZeintrag

End Sub
'------------------------------------------------------------------------
Sub ZwertEintrag
'Eintrag des Zeilenwerts nach Vorgabe des Spaltenwerts

Zanz = maxAnz \ Sanz
Babgl = maxAnz - Zanz * Sanz

if Babgl > 0 then
	Zanz = Zanz +1
'	Babgl = (Zanz * Sanz - maxAnz -1 - Sanz) * -1	'auskommentiert Version > 2.03
end if

if Babgl < 0 then	'nur zur Sicherheit, eigentlich berflssig
	msgbox Sanz & " Spalten sind bei" & vbNewLine & maxAnz & " Bildern nicht darstellbar!",vbInformation,"Hinweis"
	Sanz = Sanz + Babgl
	call ZwertEintrag
end if

call SZeintrag

End Sub
'------------------------------------------------------------------------
Sub SZeintrag

FF_SetControl "Overlapped","Zanz",Zanz
FF_SetControl "Overlapped","Sanz",Sanz

if Babgl > 0 then
	if Babgl = 1 then 
		msgAbgl = "1 Bild in Zeile"
	else
		msgAbgl = Babgl & " Bilder in Zeile"
	end if
	
	FF_SetControl "Overlapped","Zabgl",""
	FF_EnableControl "Overlapped","Zabgl", true
	for n = 1 to Zanz
		FF_SetControl "Overlapped","Zabgl",n
	next
	if Zv and Zabgl > 0 then
		FF_SetControl "Overlapped","Zabgl",Zabgl
	else
		FF_SetControl "Overlapped","Zabgl",Zanz
	end if

	FF_EnableControl "Overlapped","flagLage", true
	FF_EnableControl "Overlapped","LgWert", true
	FF_SetControl "Overlapped","||||","hor. Lage"
else
	if Sanz = 1 then
		msgAbgl = "1 Bild je Zeile"
	else
		msgAbgl = Sanz & " Bilder je Zeile"
	end if
	FF_SetControl "Overlapped","Zabgl",""
	FF_EnableControl "Overlapped","Zabgl", false
	
	FF_EnableControl "Overlapped","flagLage", false
	FF_EnableControl "Overlapped","LgWert", false
	FF_SetControl "Overlapped","||||",""
end if
FF_SetControl "Overlapped","||",msgAbgl

End Sub
'------------------------------------------------------------------------
Sub RwertEintrag

if flag_Normierung = 1 and flag_Kacheln = 1 then
	msgRwert = "Fugenbreite"
	
	FF_SetControl "Overlapped","Rwert",""
	for each element in RwertArray
		if element *1 >= 10 then
			FF_SetControl "Overlapped","Rwert",element
		end if
	next
	Rwert = abs(Rwert)
	if Rwert < 10 then Rwert = 10
	FF_SetControl "Overlapped","Rwert",Rwert
else
	FF_SetControl "Overlapped","Rwert",""
	for each element in RwertArray
		FF_SetControl "Overlapped","Rwert",element
	next
	FF_SetControl "Overlapped","Rwert",Rwert
	
	if Rwert *1 < 0 then
		msgRwert = "Zwischenraum"
	else
		msgRwert = "berlappung"
	end if
end if
FF_SetControl "Overlapped","|||",msgRwert

End Sub
'------------------------------------------------------------------------
Sub WerteAuslesen

for n = 0 to ubound(BwertArray)
	if BwertArray(n) = FF_GetControl("Overlapped","Auswahl") then
		AK = n
		exit for
	end if
next

flag_Normierung = FF_GetControl("Overlapped","flag_Normierung")
Nwert = FF_GetControl("Overlapped","SV_Auswahl")
SVsoll = ""
SVzahl_Array = split(SVzahl,"/")
for n = 0 to ubound(NwertArray)
	if NwertArray(n) = Nwert then
		SVsoll = SVzahl_Array(n)
		exit for
	end if
next
if len(SVsoll) = 0 then msgbox"Fehler beim Seitenverhltnis!",vbExclamation,"Fehler"
flag_Bautomatik = FF_GetControl("Overlapped","flag_Bautomatik")
flag_Kacheln = FF_GetControl("Overlapped","flag_Kacheln")

Zanz = FF_GetControl("Overlapped","Zanz")
Sanz = FF_GetControl("Overlapped","Sanz")
Zabgl = FF_GetControl("Overlapped","Zabgl")
if len(Zabgl) = 0 then Zabgl = 0
Zabgl = Zabgl *1

flagLage = FF_GetControl("Overlapped","flagLage")
LgWert = FF_GetControl("Overlapped","LgWert")

Sbreite = FF_GetControl("Overlapped","Sbreite")
if len(Sbreite) = 0 then Sbreite = 0
Rwert = FF_GetControl("Overlapped","Rwert")
Rwert = Rwert *1
Rfarbe = FF_GetControl("Overlapped","Rfarbe")
Rfarbwert = split(Rfarbe," ")
RRfarbe = Farbreferenz(Rfarbe)
Ewert = FF_GetControl("Overlapped","Ewert")
Efarbe = FF_GetControl("Overlapped","Efarbe")
Efarbwert = split(Efarbe," ")
Schaerfe = FF_GetControl("Overlapped","Schaerfe")

End Sub
'------------------------------------------------------------------------
Sub Kontrolle

if Sbreite < 400 then
	msgbox  "Die Collagebreite muss" & vbNewLine & _
			"mindestens 400 px betragen!",vbInformation,"Hinweis"
	Abbruch = true : exit sub
end if

if maxAnz > 30 then
	Antwort = msgbox("Sollen wirklich " & maxAnz & " Bilder verarbeitet werden?" & vbNewLine &_
					 "(Gefahr des Speichermangels!)",vbQuestion + vbYesNo,"Sicherheitsabfrage")
	if Antwort = vbNo then
		Abbruch = true : exit sub
	end if
end if

if flag_Normierung = 1 and flag_Kacheln = 1 then	'Kacheln mit Schattenbildung
	if Zabgl > 0 then
		msgbox 	"Zum 'Kacheln' muss die Anzahl der Bilder" & vbNewLine &_
				"fr jede Zeile gleich sein!",vbcritical,"Hinweis"
		Abbruch = true : exit sub
	end if

	'Bestimmung der Fugenbreite
	LinSt = round(Sbreite / 1000 * Rwert)
	Rwert = 0
	
	'Bestimmung der Gre des Gesamtrahmen
	RahSt = round(Sbreite / 1000 * Ewert)
	Ewert = 0
end if

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen

'Auswahl
AK =  FF_GetProfile (RegSchluessel,"AK")
if len(AK) = 0 then AK = 2

'Normierung
flag_Normierung =  FF_GetProfile (RegSchluessel,"flag_Normierung")
if len(flag_Normierung) = 0 then flag_Normierung = 0
Nwert =  FF_GetProfile (RegSchluessel,"Nwert")
if len(Nwert) = 0 then Nwert = " 3 :  2"
flag_Bautomatik =  FF_GetProfile (RegSchluessel,"flag_Bautomatik")
if len(flag_Bautomatik) = 0 then flag_Bautomatik = 1
Markierung =  FF_GetProfile (RegSchluessel,"Markierung")
if len(Markierung) = 0 then Markierung = 6
flag_Kacheln =  FF_GetProfile (RegSchluessel,"flag_Kacheln")
if len(flag_Kacheln) = 0 then flag_Kacheln = 0

'Bilderanordnung
Zanz =  FF_GetProfile (RegSchluessel,"Zanz")
if len(Zanz) = 0 then Zanz = 0
SRanz =  FF_GetProfile (RegSchluessel,"Sanz")
if len(SRanz) = 0 then SRanz = 0
SRanz = SRanz *1
Zabgl =  FF_GetProfile (RegSchluessel,"Zabgl")
if len(Zabgl) = 0 then Zabgl = 0
flagLage =  FF_GetProfile (RegSchluessel,"flagLage")
if len(flagLage) = 0 then flagLage = 0
LgWert =  FF_GetProfile (RegSchluessel,"LgWert")
if len(LgWert) = 0 then LgWert = "Mitte"

'Layout
Sbreite = FF_GetProfile (RegSchluessel,"Sbreite")
if len(Sbreite) = 0 then Sbreite = 800
Rwert = FF_GetProfile (RegSchluessel,"Rwert")
if len(Rwert) = 0 then Rwert = -10
Rfarbe = FF_GetProfile (RegSchluessel,"Rfarbe")
if len(Rfarbe) = 0 then Rfarbe = "255 000 000"
Ewert = FF_GetProfile (RegSchluessel,"Ewert")
if len(Ewert) = 0 then Ewert = 2
Efarbe = FF_GetProfile (RegSchluessel,"Efarbe")
if len(Efarbe) = 0 then Efarbe = "255 000 000"
Schaerfe = FF_GetProfile (RegSchluessel,"Schaerfe")
if len(Schaerfe) = 0 then Schaerfe = "keine"

'### Werte eintragen

'Auswahl
FF_SetControl "Overlapped","Auswahl",BwertArray(AK)
'Normierung
FF_SetControl "Overlapped","flag_Normierung",flag_Normierung
FF_SetControl "Overlapped","SV_Auswahl",Nwert
FF_SetControl "Overlapped","flag_Bautomatik",flag_Bautomatik
FF_SetControl "Overlapped","flag_Kacheln",flag_Kacheln
'Bilderanordnung
FF_SetControl "Overlapped","flagLage",flagLage
FF_SetControl "Overlapped","LgWert",LgWert
'Layout
FF_SetControl "Overlapped","Sbreite",Sbreite
FF_SetControl "Overlapped","Rwert",Rwert
FF_SetControl "Overlapped","Rfarbe",Rfarbe
FF_SetControl "Overlapped","Ewert",Ewert
FF_SetControl "Overlapped","Efarbe",Efarbe
FF_SetControl "Overlapped","Schaerfe",Schaerfe

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

call WerteAuslesen

'Werte schreiben
FF_WriteProfile RegSchluessel,"flag_Normierung",flag_Normierung
FF_WriteProfile RegSchluessel,"Nwert",Nwert
FF_WriteProfile RegSchluessel,"flag_Bautomatik",flag_Bautomatik
FF_WriteProfile RegSchluessel,"Markierung",Markierung
FF_WriteProfile RegSchluessel,"flag_Kacheln",flag_Kacheln
FF_WriteProfile RegSchluessel,"Zanz",Zanz
FF_WriteProfile RegSchluessel,"Sanz",Sanz
FF_WriteProfile RegSchluessel,"Zabgl",Zabgl
FF_WriteProfile RegSchluessel,"flagLage",flagLage
FF_WriteProfile RegSchluessel,"LgWert",LgWert
FF_WriteProfile RegSchluessel,"AK",AK
FF_WriteProfile RegSchluessel,"Sbreite",Sbreite
FF_WriteProfile RegSchluessel,"Rwert",Rwert
FF_WriteProfile RegSchluessel,"Rfarbe",Rfarbe
FF_WriteProfile RegSchluessel,"Ewert",Ewert
FF_WriteProfile RegSchluessel,"Efarbe",Efarbe
FF_WriteProfile RegSchluessel,"Schaerfe",Schaerfe

End Sub
'------------------------------------------------------------------------
Sub Collage_alt
'### Collageerzeugung fr FF-Version < 3.50.37

Dim overlapped,Smax,Rwertpx,zBilderArray,r,BildR,Swert

'Vorberechnungen
Babgl = Babgl *1
Ewertpx = round(Sbreite / 1000 * Ewert)
Sbreite = Sbreite - 2* Ewertpx

'berlappung oder Rand
if Rwert < 0 then
	overlapped = false
	Rwert = Rwert * -1
else
	overlapped = true
end if

'Bilderzeilen erstellen
n = 0
for z = 1 to Zanz
	if z = Zabgl then Smax = Babgl -1 else Smax = Sanz -1
	zBilder = ""
	if n = 0 then Collection = objFS.GetFileName(bilderArray(0))					'fr den Exif-Kommentar
	for s = 0 to Smax
		if n >= maxAnz then Zunz = true : exit for									'Kontrolle der Bildanzahl
		if n > 0 then
			Collection = Collection & vbCrLf & objFS.GetFileName(bilderArray(n))	'fr den Exif-Kommentar
		end if
		if len(zBilder) = 0 then
			zBilder = bilderArray(n)												'Bildnamen einer Zeile sammeln
		else
			zBilder = zBilder & vbNewLine & bilderArray(n)
		end if
		n = n +1
		FF_SetControl "Overlapped","Fortschritt",(z + n)/(Zanz + maxAnz) * 100
	next
	
	if Zunz then exit for																	'vorzeitge Beendigung bei
																							'   negativer Kontrolle der Bildanzahl
	FF_MakeBanner zBilder,0			'zur Ermittlung der Breite einer Zeile
	Gbreite = FF_GetImageWidth
	lapPx = round(Gbreite / 1000 * Rwert)
	
	'Lage Links, Rechts oder Mitte
	if flagLage = 1 and z = Zabgl then
		Bildname = bildN & "_New.jpg"
		Select Case LgWert
			Case "Links"
				FF_NewImage (Gbreite / Babgl + lapPx) * (Sanz - Babgl),FF_GetImageHeight,RRfarbe
				zBilder = zBilder & vbNewLine & Bildname
			Case "Mitte"
				FF_NewImage (Gbreite / Babgl + lapPx) * (Sanz - Babgl) / 2,FF_GetImageHeight,RRfarbe
				zBilder = Bildname & vbNewLine & zBilder & vbNewLine & Bildname
			Case "Rechts"
				FF_NewImage (Gbreite / Babgl + lapPx) * (Sanz - Babgl),FF_GetImageHeight,RRfarbe
				zBilder = Bildname & vbNewLine & zBilder
		End Select
		FF_SaveImage Bildname,0

		Gbreite = Gbreite + (Gbreite / Babgl + lapPx) * (Sanz - Babgl)
		lapPx = round(Gbreite / 1000 * Rwert)
	end if

	if not overlapped then
		Rwertpx = lapPx : lapPx = 0
		zBilderArray = split(zBilder,vbNewLine)												'Bilder einer Zeile bearbeiten
		FF_LoadImage zBilderArray(0)
		if z > 1 then FF_ExtendCanvas 0,0,Rwertpx,0,Rfarbwert(0),Rfarbwert(1),Rfarbwert(2)	'farbiger Zw.Raum

		BildR = BildN & "R0" & ".jpg"														'Bildname mit Zw.Raum
		FF_SaveImage BildR,0																'   temporr speichern
		zBilder = BildR
		for r = 1 to ubound(zBilderArray)
			FF_LoadImage zBilderArray(r)
			if z > 1 then
				FF_ExtendCanvas Rwertpx,0,Rwertpx,0,Rfarbwert(0),Rfarbwert(1),Rfarbwert(2)	'farbiger Zw.Raum
			else
				FF_ExtendCanvas Rwertpx,0,0,0,Rfarbwert(0),Rfarbwert(1),Rfarbwert(2)		'farbiger Zw.Raum
			end if
			BildR = BildN & "R" & r & ".jpg"												'Bildname mit Zw.Raum
			FF_SaveImage BildR,0															'   temporr speichern
			zBilder = zBilder & vbNewLine & BildR											'Bildnamen einer Zeile sammeln
		next
	end if

	FF_MakeBanner zBilder,lapPx																'Banner fr eine Zeile erstellen
	if z = 1 then FF_HQScale Sbreite,Sbreite,true											'skalieren auf Sollbreite
	FF_Rotate 270,0,0																		'   und in die Vertikale drehen
	
	Bildname = bildN & z & ".jpg"															'Bildname fr die Zeile festlegen
	FF_SaveImage Bildname,0																	'   und speichern

	if len(zGbilder) = 0 then
		zGbilder = Bildname																	'Bildnamen fr die Bannerzeilen
	else																					'   sammeln
		zGbilder = zGbilder & vbnewline & Bildname
	end if
next

'Zeilen verbinden
if overlapped then lapPx = round(Sbreite / 1000 * Rwert)
FF_MakeBanner zGbilder,lapPx																'Bannerzeilen zu einem Banner
FF_Rotate 90,0,0																			'   und in die Horizontale drehen
call Collage_Allgemein

End Sub
'------------------------------------------------------------------------
Sub Collage
'### Collageerzeugung fr FF-Version >= 3.50.37

Dim Smax

'Vorberechnungen
Ewertpx = round(Sbreite / 1000 * Ewert)
Sbreite = Sbreite - 2* Ewertpx

'Bilderzeilen erstellen
n = 0
for z = 1 to Zanz
	if z = Zabgl then Smax = Babgl -1 else Smax = Sanz -1
	zBilder = ""
	if n = 0 then Collection = objFS.GetFileName(bilderArray(0))					'fr den Exif-Kommentar
	
	for s = 0 to Smax
	
		if n >= maxAnz then Zunz = true : exit for									'Kontrolle der Bildanzahl
		
		if n > 0 then
			Collection = Collection & vbCrLf & objFS.GetFileName(bilderArray(n))	'fr den Exif-Kommentar
		end if
		
		if len(zBilder) = 0 then
			zBilder = bilderArray(n)												'Bildnamen einer Zeile
		else
			zBilder = zBilder & vbNewLine & bilderArray(n)
		end if
		
		n = n +1
		FF_SetControl "Overlapped","Fortschritt",n/maxAnz * 100
	next
	
	if Zunz then exit for							'vorzeitige Beendigung bei neg. Kontrolle der Bildanzahl
	
	FF_MakeBanner zBilder,0,0						'zur Ermittlung der Breite einer Zeile
	Gbreite = FF_GetImageWidth
	lapPx = round(Gbreite / 1000 * Rwert)
	
	'Lage Links, Rechts oder Mitte
	if flagLage = 1 and z = Zabgl then
		Bildname = bildN & "_New.jpg"
		Select Case LgWert
			Case "Links"
				FF_NewImage (Gbreite / Babgl - lapPx) * (Sanz - Babgl),FF_GetImageHeight,RRfarbe
				zBilder = zBilder & vbNewLine & Bildname
			Case "Mitte"
				FF_NewImage (Gbreite / Babgl - lapPx) * (Sanz - Babgl) / 2,FF_GetImageHeight,RRfarbe
				zBilder = Bildname & vbNewLine & zBilder & vbNewLine & Bildname
			Case "Rechts"
				FF_NewImage (Gbreite / Babgl - lapPx) * (Sanz - Babgl),FF_GetImageHeight,RRfarbe
				zBilder = Bildname & vbNewLine & zBilder
		End Select
		FF_SaveImage Bildname,0
		
		Gbreite = Gbreite + (Gbreite / Babgl - lapPx) * (Sanz - Babgl)
		lapPx = round(Gbreite / 1000 * Rwert)
	end if
	
	FF_MakeBanner zBilder,lapPx,RRfarbe				'Banner erzeugen fr eine Zeile,
	if z = 1 then FF_HQScale Sbreite,Sbreite,true	'  diesen skalieren auf Sollbreite
	FF_Rotate 270,0,0								'  und in die Vertikale drehen
	
	Bildname = bildN & z & ".jpg"					'fr eine Zeile Bildname erzeugen und abspeichern
	FF_SaveImage Bildname,0

	if len(zGbilder) = 0 then
		zGbilder = Bildname							'Bildnamen aller Zeilen sammeln
	else
		zGbilder = zGbilder & vbnewline & Bildname
	end if
next

'Zeilen verbinden
lapPx = round(Sbreite / 1000 * Rwert)
FF_MakeBanner zGbilder,lapPx,RRfarbe				'Bannerzeilen zu einem Banner
FF_Rotate 90,0,0									'   und in die Horizontale drehen

call Collage_Allgemein

End Sub
'------------------------------------------------------------------------
Sub Collage_Allgemein
'versionsunabhngiger Teil der Collageerzeugung

if flag_Normierung = 0 or flag_Kacheln = 0 then
	'Endrahmen
	if Ewertpx > 0 then
		FF_ExtendCanvas Ewertpx,Ewertpx,Ewertpx,Ewertpx,Efarbwert(0),Efarbwert(1),Efarbwert(2)
	end if
end if

'Nachschrfung
call Schaerfung 

'Exif-Daten
if FF_HasExif then FF_KillExif 
FF_CreateExif
FF_SetExifTag "ImageDescription","Collage"
FF_SetExifTag "UserComment","erstellt mit den Bildern:" & vbCrLf & Collection
FF_SetExifTag "Software","FF-Skript Overlapped"

'Meldung bei ungengender Bilderanzahl fr gewhlte Zeilenanzahl
if ZeilenKontrolle and Zunz then
	msgbox "Fr die Zeile " & z & " standen nicht gengend Bilder zur Verfgung!",vbInformation,"Hinweis"
	Abbruch = true
end if

End Sub
'------------------------------------------------------------------------
Sub Schaerfung
Dim Swert

if Schaerfe <> "keine" then
	select case Schaerfe
		case "schwach"
			Swert = S_schwach
		case "mittel"
			Swert = S_mittel
		case "stark"
			Swert = S_stark
	case else
		msgbox "Schwerer Schrfe-Fehler!",vbExclamation,"Abbruch"
		exit sub
	end select

	if RGB_S then FF_Sharp Swert,true,true,true
	if Y_S then FF_YSharp Swert
end if

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
Sub Update

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Delete-Funktion
'************************************************************************
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### beigepackten Ordner lschen
TempFile = FF_GetScriptPath & "\MeckiScript\Overlapped"
if objFS.FolderExists(TempFile) then objFS.DeleteFolder TempFile,true

'### ggf. Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Allgemein
'************************************************************************
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
Function Farbreferenz (RGB_Wert)
'RGB-Wert ("000 000 000" bis "255 255 255") zu Farbreferenz (0 - 16777215)
Dim C_Array
	C_Array = split(RGB_Wert," ")
	Farbreferenz = C_Array(0) + C_Array(1) * (2^8) + C_Array(2) * (2^16)
End Function
'--------------------------------------------------------------
